ynh-vpnclient 8.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257
  1. #!/bin/bash
  2. # VPN Client app for YunoHost
  3. # Copyright (C) 2015 Julien Vaubourg <julien@vaubourg.com>
  4. # Contribute at https://github.com/labriqueinternet/vpnclient_ynh
  5. #
  6. # This program is free software: you can redistribute it and/or modify
  7. # it under the terms of the GNU Affero General Public License as published by
  8. # the Free Software Foundation, either version 3 of the License, or
  9. # (at your option) any later version.
  10. #
  11. # This program is distributed in the hope that it will be useful,
  12. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. # GNU Affero General Public License for more details.
  15. #
  16. # You should have received a copy of the GNU Affero General Public License
  17. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  18. ###################################################################################
  19. # Logging helpers #
  20. ###################################################################################
  21. LOGFILE="/var/log/ynh-vpnclient.log"
  22. touch $LOGFILE
  23. chown root:root $LOGFILE
  24. chmod 600 $LOGFILE
  25. function success()
  26. {
  27. echo "[ OK ] $1" | tee -a $LOGFILE
  28. }
  29. function info()
  30. {
  31. echo "[INFO] $1" | tee -a $LOGFILE
  32. }
  33. function warn()
  34. {
  35. echo "[WARN] $1" | tee -a $LOGFILE >&2
  36. }
  37. function error()
  38. {
  39. echo "[FAIL] $1" | tee -a $LOGFILE >&2
  40. }
  41. function critical()
  42. {
  43. echo "[CRIT] $1" | tee -a $LOGFILE >&2
  44. exit 1
  45. }
  46. ###################################################################################
  47. # Cleanup #
  48. ###################################################################################
  49. cleanup() {
  50. local last_exit_code="$?"
  51. if [[ "${action}" != "stop" && "${last_exit_code}" -ne 0 ]]; then
  52. rm -f /tmp/.ynh-vpnclient-started
  53. fi
  54. }
  55. # Cleanup before exit
  56. trap cleanup 0
  57. ###################################################################################
  58. # Time sync #
  59. ###################################################################################
  60. sync_time() {
  61. info "Now synchronizing time using ntp..."
  62. systemctl stop ntp
  63. timeout 20 ntpd -qg &> /dev/null
  64. # Some networks drop ntp port (udp 123).
  65. # Try to get the date with an http request on the internetcube web site
  66. if [ $? -ne 0 ]; then
  67. info "ntp synchronization failed, falling back to curl method"
  68. http_date=$(curl --max-time 5 -sD - yunohost.org | grep -i '^Date:' | cut -d' ' -f2-)
  69. http_date_seconds=$(date -d "${http_date}" +%s)
  70. curr_date_seconds=$(date +%s)
  71. # Set the new date if it's greater than the current date
  72. # So it does if 1970 year or if old fake-hwclock date is used
  73. if [ $http_date_seconds -ge $curr_date_seconds ]; then
  74. date -s "${http_date}"
  75. fi
  76. fi
  77. systemctl start ntp
  78. }
  79. ###################################################################################
  80. # The actual ynh vpnclient management thing #
  81. ###################################################################################
  82. check_config() {
  83. info "Checking if configuration is valid..."
  84. if [[ ! -e /etc/openvpn/keys/ca-server.crt ]]; then
  85. critical "You need a CA server (you can add it through the web admin)"
  86. fi
  87. if ! openssl x509 -in /etc/openvpn/keys/ca-server.crt -noout -checkend 0 >/dev/null; then
  88. ca_server_cert_expired_date=$(openssl x509 -in /etc/openvpn/keys/ca-server.crt -noout -enddate | cut -d '=' -f 2)
  89. critical "The CA server expired on $ca_server_cert_expired_date"
  90. fi
  91. if [[ ! -e /etc/openvpn/keys/user.crt || ! -e /etc/openvpn/keys/user.key ]]; then
  92. if [[ -s /etc/openvpn/keys/credentials ]]; then
  93. login_user=$(sed -n 1p /etc/openvpn/keys/credentials)
  94. login_passphrase=$(sed -n 2p /etc/openvpn/keys/credentials)
  95. else
  96. login_user=""
  97. login_passphrase=""
  98. fi
  99. if [[ $login_user == "" || $login_passphrase == "" ]]; then
  100. critical "You need either a client certificate, either a username, or both (you can add one through the web admin)"
  101. fi
  102. elif [[ -e /etc/openvpn/keys/user.crt ]] && ! openssl x509 -in /etc/openvpn/keys/user.crt -noout -checkend 0 >/dev/null; then
  103. user_cert_expired_date=$(openssl x509 -in /etc/openvpn/keys/user.crt -noout -enddate | cut -d '=' -f 2)
  104. critical "The client certificate expired on $user_cert_expired_date"
  105. fi
  106. }
  107. action=${1}
  108. if [[ "$action" != restart ]]; then
  109. # Variables
  110. info "Retrieving Yunohost settings... "
  111. ynh_service_enabled=$(yunohost app setting "vpnclient" "service_enabled")
  112. success "Settings retrieved"
  113. fi
  114. ###################################################################################
  115. # Start / stop / restart / status handling #
  116. ###################################################################################
  117. case "$action" in
  118. # ########## #
  119. # Starting #
  120. # ########## #
  121. start)
  122. info "[vpnclient] Starting..."
  123. if [[ -e /tmp/.ynh-vpnclient.started ]] || systemctl -q is-active openvpn@client.service; then
  124. info "Service is already running"
  125. exit 0
  126. elif [[ "${ynh_service_enabled}" -eq 0 ]]; then
  127. warn "Service is disabled, not starting it"
  128. exit 0
  129. fi
  130. touch /tmp/.ynh-vpnclient-started
  131. sync_time
  132. check_config
  133. info "Now actually starting OpenVPN client..."
  134. if systemctl start openvpn@client.service; then
  135. info "OpenVPN client started ... waiting for tun0 interface to show up"
  136. else
  137. tail -n 20 /var/log/openvpn-client.log | tee -a $LOGFILE
  138. critical "Failed to start OpenVPN :/"
  139. fi
  140. has_errors=true
  141. for attempt in $(seq 0 20); do
  142. sleep 1
  143. if ip link show dev tun0 &> /dev/null; then
  144. success "tun0 interface is up!"
  145. has_errors=false
  146. break
  147. fi
  148. done
  149. if $has_errors; then
  150. error "Tun0 interface did not show up ... most likely an issue happening in OpenVPN client ... below is an extract of the log that might be relevant to pinpoint the issue"
  151. tail -n 20 /var/log/openvpn-client.log | tee -a $LOGFILE
  152. systemctl stop openvpn@client.service
  153. critical "Failed to start OpenVPN client : tun0 interface did not show up"
  154. fi
  155. info "Waiting for VPN client to be ready..."
  156. if ! timeout 180 tail -n 0 -f /var/log/openvpn-client.log | grep -q "Initialization Sequence Completed"; then
  157. error "The VPN client didn't complete initiliasation"
  158. tail -n 20 /var/log/openvpn-client.log | tee -a $LOGFILE
  159. systemctl stop openvpn@client.service
  160. critical "Failed to start OpenVPN client"
  161. fi
  162. info "Validating that VPN is up and the server is connected to internet..."
  163. ipv4=$(timeout 5 ping -w3 -c1 ip.yunohost.org >/dev/null 2>&1 && curl --max-time 5 https://ip.yunohost.org --silent)
  164. ipv6=$(timeout 5 ping -w3 -c1 ip6.yunohost.org >/dev/null 2>&1 && curl --max-time 5 https://ip6.yunohost.org --silent)
  165. if ip route get 1.2.3.4 | grep -q tun0; then
  166. if timeout 5 ping -c1 -w3 debian.org >/dev/null; then
  167. success "YunoHost VPN client started!"
  168. info "IPv4 address is $ipv4"
  169. info "IPv6 address is $ipv6"
  170. else
  171. critical "The VPN is up but debian.org cannot be reached, indicating that something is probably misconfigured/blocked."
  172. fi
  173. else
  174. critical "[CRIT] IPv4 routes are misconfigured !?"
  175. fi
  176. ;;
  177. # ########## #
  178. # Stopping #
  179. # ########## #
  180. stop)
  181. info "[vpnclient] Stopping..."
  182. rm -f /tmp/.ynh-vpnclient-started
  183. if systemctl is-active -q openvpn@client.service; then
  184. info "Stopping OpenVPN service"
  185. systemctl stop openvpn@client.service
  186. for attempt in $(seq 0 20); do
  187. if ip link show dev tun0 &> /dev/null; then
  188. info "(Waiting for tun0 to disappear if it was up)"
  189. sleep 1
  190. fi
  191. done
  192. fi
  193. ;;
  194. # ########## #
  195. # Restart #
  196. # ########## #
  197. restart)
  198. $0 stop
  199. $0 start
  200. ;;
  201. # ########## #
  202. # Halp #
  203. # ########## #
  204. *)
  205. echo "Usage: $0 {start|stop|restart}"
  206. ;;
  207. esac
  208. exit 0